	package examples;

import java.awt.event.ComponentAdapter;

public class InstanceOfTest {

	public static class TestClass
	{
		
	}
	
	public static class SubTestClass extends TestClass
	{
		
	}
	
	public static class SubSubTestClass extends SubTestClass
	{
		
	}

	
	public static void main(String[] args) 
	{
		SubSubTestClass instance = new SubSubTestClass();
		if (instance instanceof SubTestClass) {
			if (instance instanceof TestClass) {
				if (!(instance instanceof Comparable)) {
					InterfaceImplementerClass impl = new InterfaceImplementerClass();
					if (impl instanceof Comparable) {
						if (impl instanceof ComponentAdapter) {
							if (!(impl instanceof Iterable)) {
								// assert is only reached if all instanceof tests work correctly
								assert(false);
							}
						}
					}
				}
			}
		}
	}
	

	public static class InterfaceImplementerClass extends ComponentAdapter implements Comparable
	{

		public int compareTo(Object o)
		{
			return 0;
		}
		
	}
}
