package coinchanging;

/**
 * Changes to make it work with moped: 
 * 
 * 1) Initialized array for unit tests.
 * 2) Moveed statements into extra lines
 *
 * Parameters
 * 
 * 4 bits 15 heapsize
 */
class Change {
	
	
  private static int[] c = {10,5,4,1};

  public static void test(int amount)
  {
	  int change = change(amount, c);
	  assert(change == Greedy.change(amount, c));
  }
  
  public static int change(int amount, int[] coins){
     c = coins;
     return change(amount,0);
  }           
  private static int change(int amount, int j) {     
    if (amount == 0)
    	return(0);
    if (j == c.length) 
    	return(Integer.MAX_VALUE);
    if (amount < c[j]) 
    	return(change(amount,j+1));
    else {
      int c1 = change(amount,j+1);
      int c2 = 1 + change(amount-c[j],j);
      if (c1 < c2) 
    	  return(c1);
      else 
    	  return(c2);
    }
  }
}
